/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec & Analyzer                                              */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Copyright (C) 2006 Andrei Grecu <e0125662@student.tuwien.ac.at>		      */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 18.01.2006                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


#include <windows.h>

#include "inttypes.h"

#include "config.h"
#include "resource.h"


/****************************************
	global configuration
****************************************/

configvars_t myconfig, tempconfig;
lpconfigvars_t lpmyconfig = &myconfig;
lpconfigvars_t lptempconfig = &tempconfig;

configvars_t myconfig_default = {
	1,	// encoder_quality_mode
	0,	// encoder_force_input_format = 0;
	COLORFORMAT_YUY2,	// encoder_input_format;
	0,	// encoder_RGB_to_YUV_conversion = 0;
	YV12_CHROMASAMPLING_MPEG2_P,	// encoder_yv12_chroma_sampling;
	10,	// encoder_dct248_threshold = 10;
	15,	// encoder_dct248_counts = 15;
	0,	// encoder_coring_enable = 0;
	{	// encoder_coring_matrix[64]
	    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0, 1023,
	    0,    0,    0,    0,    0,    0, 1023, 1023,
	    0,    0,    0,    0,    0, 1023, 1023, 1023,
	    0,    0,    0,    0, 1023, 1023, 1023, 1023,
	    0,    0,    0, 1023, 1023, 1023, 1023, 1023,
	    0,    0, 1023, 1023, 1023, 1023, 1023, 1023
	},
	{ 12, 24, 36 },	// encoder_classification_Y[3]
	{  0, 12, 24 },	// encoder_classification_V[3]
	{  0,  0, 12 },	// encoder_classification_U[3]
	0,	// decoder_force_output_format = 0;
	COLORFORMAT_YUY2,	// decoder_output_format = 1;
	0,	// decoder_YUV_to_RGB_conversion = 0;
	YV12_CHROMASAMPLING_MPEG2_P,	// decoder_YV12_chroma_sampling;
	COLORFORMAT_YUY2,  // showing block errors deactivated, but preset to using YUY2
	COLORFORMAT_YUY2,  // showing dct type deactivated, but preset to using YUY2
	COLORFORMAT_YUY2,  // showing block class deactivated, but preset to using YUY2
	COLORFORMAT_YUY2,  // showing quantizer number deactivated, but preset to using YUY2
	COLORFORMAT_YUY2   // showing quantizer decoded deactivated, but preset to using YUY2
};
lpconfigvars_t lpmyconfig_default = &myconfig_default;


char *quality_mode_names[NO_OF_QUALITY_MODES] = {
	"high", "normal", "fast", "ultra fast" };



int load_configuration( char *my_config_filename )
{
	BOOL bReturn;

	memcpy( lpmyconfig, lpmyconfig_default, sizeof(configvars_t) );

	bReturn = GetPrivateProfileStruct("main", 
		"all", lpmyconfig, sizeof(configvars_t), my_config_filename );

	return 0;

/*
	lpmyconfig->encoder_quality_mode = GetPrivateProfileInt("encoder", 
		"encoder_quality_mode", lpmyconfig_default->encoder_quality_mode, my_config_filename);
	lpmyconfig->encoder_force_input_format = GetPrivateProfileInt("encoder", 
		"encoder_force_input_format", lpmyconfig_default->encoder_force_input_format, my_config_filename);
	lpmyconfig->encoder_input_format = GetPrivateProfileInt("encoder", 
		"encoder_input_format", lpmyconfig_default->encoder_input_format, my_config_filename);
	lpmyconfig->encoder_RGB_to_YUV_conversion = GetPrivateProfileInt("encoder", 
		"encoder_RGB_to_YUV_conversion", lpmyconfig_default->encoder_RGB_to_YUV_conversion, my_config_filename);
	lpmyconfig->encoder_YV12_chroma_sampling = GetPrivateProfileInt("encoder", 
		"encoder_YV12_chroma_sampling", lpmyconfig_default->encoder_YV12_chroma_sampling, my_config_filename);
	lpmyconfig->encoder_dct248_threshold = GetPrivateProfileInt("encoder", 
		"encoder_dct248_threshold", lpmyconfig_default->encoder_dct248_threshold, my_config_filename);
	lpmyconfig->encoder_dct248_counts = GetPrivateProfileInt("encoder", 
		"encoder_dct248_counts", lpmyconfig_default->encoder_dct248_counts, my_config_filename);
	lpmyconfig->encoder_coring_enable = GetPrivateProfileInt("encoder", 
		"encoder_coring_enable", lpmyconfig_default->encoder_coring_enable, my_config_filename);

	GetPrivateProfileStruct("encoder", 
		"encoder_classification_Y", lpmyconfig->encoder_classification_Y, 3*sizeof(int), my_config_filename);
	GetPrivateProfileStruct("encoder", 
		"encoder_classification_V", lpmyconfig->encoder_classification_V, 3*sizeof(int), my_config_filename);
	GetPrivateProfileStruct("encoder", 
		"encoder_classification_U", lpmyconfig->encoder_classification_U, 3*sizeof(int), my_config_filename);
	GetPrivateProfileStruct("encoder", 
		"encoder_coring_matrix", lpmyconfig->encoder_coring_matrix, 64*sizeof(int16_t), my_config_filename);

	lpmyconfig->decoder_force_output_format = GetPrivateProfileInt("decoder", 
		"decoder_force_output_format", lpmyconfig_default->decoder_force_output_format, my_config_filename);
	lpmyconfig->decoder_output_format = GetPrivateProfileInt("decoder", 
		"decoder_output_format", lpmyconfig_default->decoder_output_format, my_config_filename);
	lpmyconfig->decoder_YUV_to_RGB_conversion = GetPrivateProfileInt("decoder", 
		"decoder_YUV_to_RGB_conversion", lpmyconfig_default->decoder_YUV_to_RGB_conversion, my_config_filename);
	lpmyconfig->decoder_YV12_chroma_sampling = GetPrivateProfileInt("decoder", 
		"decoder_YV12_chroma_sampling", lpmyconfig_default->decoder_YV12_chroma_sampling, my_config_filename);
*/

}

int save_configuration( char *my_config_filename )
{
	BOOL bReturn;

	bReturn = WritePrivateProfileStruct("main", "all", lpmyconfig, sizeof(configvars_t), my_config_filename);
	
	return 0;
}


#define LIMIT_MIN_MAX( x, xmin, xmax ) ( ((x)<xmin) ? xmin : ( ((x)>xmax) ? xmax : (x) ) )

BOOL CALLBACK ConfigureDialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	int i;
	int iTemp;
	//BOOL disable_buttons;

	if (uMsg == WM_INITDIALOG) {

		//load_configuration(CONFIGURATION_FILENAME);

		// quality mode
		HWND hctl_quality_mode = GetDlgItem(hwndDlg, IDC_QUALITY_MODE);

		for (i=0; i < NO_OF_QUALITY_MODES; i++) {
		  SendMessage(hctl_quality_mode, CB_ADDSTRING, 0, (LPARAM)quality_mode_names[i]);
		}

		SendMessage(hctl_quality_mode, CB_SETCURSEL, lpmyconfig->encoder_quality_mode, 0);

		// input format
		CheckDlgButton(hwndDlg, IDC_FORCE_INPUT_FORMAT, lpmyconfig->encoder_force_input_format ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_FIF_RGB, (lpmyconfig->encoder_input_format==COLORFORMAT_RGB32) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_FIF_YUY2, (lpmyconfig->encoder_input_format==COLORFORMAT_YUY2) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_FIF_YV12, (lpmyconfig->encoder_input_format==COLORFORMAT_YV12) ? BST_CHECKED : BST_UNCHECKED );
		
/*		if (!lpmyconfig->encoder_force_input_format) 
		{
			SendMessage(GetDlgItem(hwndDlg, IDC_FIF_RGB), BM_SETSTATE, TRUE, 0);
			SendMessage(GetDlgItem(hwndDlg, IDC_FIF_YUY2), BM_SETSTATE, TRUE, 0);
			SendMessage(GetDlgItem(hwndDlg, IDC_FIF_YV12), BM_SETSTATE, TRUE, 0);
		}
*/

		// rgb-to-yuv conversion
		CheckDlgButton(hwndDlg, IDC_RGB2YUV_601, (lpmyconfig->encoder_RGB_to_YUV_conversion==RGB2YUV_601) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_RGB2YUV_UNCHANGED, (lpmyconfig->encoder_RGB_to_YUV_conversion==RGB2YUV_UNCHANGED) ? BST_CHECKED : BST_UNCHECKED );

		// input yv12 chroma sampling
		CheckDlgButton(hwndDlg, IDC_YV12_CHROMA_IN_DV, (lpmyconfig->encoder_YV12_chroma_sampling==YV12_CHROMASAMPLING_DV) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_YV12_CHROMA_IN_MPEG2_PROGRESSIVE, (lpmyconfig->encoder_YV12_chroma_sampling==YV12_CHROMASAMPLING_MPEG2_P) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_YV12_CHROMA_IN_MPEG2_INTERLACED, (lpmyconfig->encoder_YV12_chroma_sampling==YV12_CHROMASAMPLING_MPEG2_I) ? BST_CHECKED : BST_UNCHECKED );

//IDC_DCT248_THRESHOLD            1044
//IDC_DCT248_COUNTS               1045
//IDC_CORING                      1018

		// output format
		CheckDlgButton(hwndDlg, IDC_FORCE_OUTPUT_FORMAT, lpmyconfig->decoder_force_output_format ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_FOF_RGB, (lpmyconfig->decoder_output_format==COLORFORMAT_RGB32) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_FOF_YUY2, (lpmyconfig->decoder_output_format==COLORFORMAT_YUY2) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_FOF_YV12, (lpmyconfig->decoder_output_format==COLORFORMAT_YV12) ? BST_CHECKED : BST_UNCHECKED );
/*		
		if (!lpmyconfig->decoder_force_output_format)
		{
			SendMessage(GetDlgItem(hwndDlg, IDC_FOF_RGB), BM_SETSTATE, TRUE, 0);
			SendMessage(GetDlgItem(hwndDlg, IDC_FOF_YUY2), BM_SETSTATE, TRUE, 0);
			SendMessage(GetDlgItem(hwndDlg, IDC_FOF_YV12), BM_SETSTATE, TRUE, 0);
		}
*/
		// yuv-to-rgb conversion
		CheckDlgButton(hwndDlg, IDC_YUY2RGB_601, (lpmyconfig->decoder_YUV_to_RGB_conversion==RGB2YUV_601) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_YUY2RGB_UNCHANGED, (lpmyconfig->decoder_YUV_to_RGB_conversion==RGB2YUV_UNCHANGED) ? BST_CHECKED : BST_UNCHECKED );

		// output yv12 chroma sampling
		CheckDlgButton(hwndDlg, IDC_YV12_CHROMA_OUT_DV, (lpmyconfig->decoder_YV12_chroma_sampling==YV12_CHROMASAMPLING_DV) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_YV12_CHROMA_OUT_MPEG2_PROGRESSIVE, (lpmyconfig->decoder_YV12_chroma_sampling==YV12_CHROMASAMPLING_MPEG2_P) ? BST_CHECKED : BST_UNCHECKED );
		CheckDlgButton(hwndDlg, IDC_YV12_CHROMA_OUT_MPEG2_INTERLACED, (lpmyconfig->decoder_YV12_chroma_sampling==YV12_CHROMASAMPLING_MPEG2_I) ? BST_CHECKED : BST_UNCHECKED );

		// dct-248 mode selection
		SetDlgItemInt(hwndDlg, IDC_DCT248_THRESHOLD,lpmyconfig->encoder_dct248_threshold, FALSE);
		SetDlgItemInt(hwndDlg, IDC_DCT248_COUNTS, lpmyconfig->encoder_dct248_counts, FALSE);

		// classification
		SetDlgItemInt(hwndDlg, IDC_CLASS_Y0,lpmyconfig->encoder_classification_Y[0], FALSE);
		SetDlgItemInt(hwndDlg, IDC_CLASS_Y1,lpmyconfig->encoder_classification_Y[1], FALSE);
		SetDlgItemInt(hwndDlg, IDC_CLASS_Y2,lpmyconfig->encoder_classification_Y[2], FALSE);
		SetDlgItemInt(hwndDlg, IDC_CLASS_CR0, lpmyconfig->encoder_classification_V[0], FALSE);
		SetDlgItemInt(hwndDlg, IDC_CLASS_CR1, lpmyconfig->encoder_classification_V[1], FALSE);
		SetDlgItemInt(hwndDlg, IDC_CLASS_CR2, lpmyconfig->encoder_classification_V[2], FALSE);
		SetDlgItemInt(hwndDlg, IDC_CLASS_CB0, lpmyconfig->encoder_classification_U[0], FALSE);
		SetDlgItemInt(hwndDlg, IDC_CLASS_CB1, lpmyconfig->encoder_classification_U[1], FALSE);
		SetDlgItemInt(hwndDlg, IDC_CLASS_CB2, lpmyconfig->encoder_classification_U[2], FALSE);

		// analyzer settings
		CheckDlgButton(hwndDlg, IDC_SHOW_BE,   ((lpmyconfig->analyzer_show_block_errors      & 0x40000000) > 0) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_DCTT, ((lpmyconfig->analyzer_show_dct_type          & 0x40000000) > 0) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_BC,   ((lpmyconfig->analyzer_show_block_class       & 0x40000000) > 0) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_QN,   ((lpmyconfig->analyzer_show_quantizer_number  & 0x40000000) > 0) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_QD,   ((lpmyconfig->analyzer_show_quantizer_decoded & 0x40000000) > 0) ? BST_CHECKED : BST_UNCHECKED);

		// analyzer color spaces
		CheckDlgButton(hwndDlg, IDC_SHOW_BE_YUY2,    ((lpmyconfig->analyzer_show_block_errors      & 0x3FFFFFFF) == COLORFORMAT_YUY2 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_BE_YV12,    ((lpmyconfig->analyzer_show_block_errors      & 0x3FFFFFFF) == COLORFORMAT_YV12 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_BE_RGB24,   ((lpmyconfig->analyzer_show_block_errors      & 0x3FFFFFFF) == COLORFORMAT_RGB24) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_BE_RGB32,   ((lpmyconfig->analyzer_show_block_errors      & 0x3FFFFFFF) == COLORFORMAT_RGB32) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_DCTT_YUY2,  ((lpmyconfig->analyzer_show_dct_type          & 0x3FFFFFFF) == COLORFORMAT_YUY2 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_DCTT_YV12,  ((lpmyconfig->analyzer_show_dct_type          & 0x3FFFFFFF) == COLORFORMAT_YV12 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_DCTT_RGB24, ((lpmyconfig->analyzer_show_dct_type          & 0x3FFFFFFF) == COLORFORMAT_RGB24) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_DCTT_RGB32, ((lpmyconfig->analyzer_show_dct_type          & 0x3FFFFFFF) == COLORFORMAT_RGB32) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_BC_YUY2,    ((lpmyconfig->analyzer_show_block_class       & 0x3FFFFFFF) == COLORFORMAT_YUY2 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_BC_YV12,    ((lpmyconfig->analyzer_show_block_class       & 0x3FFFFFFF) == COLORFORMAT_YV12 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_BC_RGB24,   ((lpmyconfig->analyzer_show_block_class       & 0x3FFFFFFF) == COLORFORMAT_RGB24) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_BC_RGB32,   ((lpmyconfig->analyzer_show_block_class       & 0x3FFFFFFF) == COLORFORMAT_RGB32) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_QN_YUY2,    ((lpmyconfig->analyzer_show_quantizer_number  & 0x3FFFFFFF) == COLORFORMAT_YUY2 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_QN_YV12,    ((lpmyconfig->analyzer_show_quantizer_number  & 0x3FFFFFFF) == COLORFORMAT_YV12 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_QD_YUY2,    ((lpmyconfig->analyzer_show_quantizer_decoded & 0x3FFFFFFF) == COLORFORMAT_YUY2 ) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_SHOW_QD_YV12,    ((lpmyconfig->analyzer_show_quantizer_decoded & 0x3FFFFFFF) == COLORFORMAT_YV12 ) ? BST_CHECKED : BST_UNCHECKED);
    }

	else if (uMsg == WM_COMMAND) {

		switch (LOWORD(wParam)) {
/*
		case IDC_FOF_RGB:
		case IDC_FOF_YUY2:
		case IDC_FOF_YV12:
		case IDC_FORCE_OUTPUT_FORMAT:
			disable_buttons = !(IsDlgButtonChecked(hwndDlg, IDC_FORCE_OUTPUT_FORMAT) == BST_CHECKED);
			{
				SendMessage(GetDlgItem(hwndDlg, IDC_FOF_RGB), BM_SETSTATE, disable_buttons, 0);
				SendMessage(GetDlgItem(hwndDlg, IDC_FOF_YUY2), BM_SETSTATE, disable_buttons, 0);
				SendMessage(GetDlgItem(hwndDlg, IDC_FOF_YV12), BM_SETSTATE, disable_buttons, 0);
			}
			break;
*/
		case IDOK:

			// quality-mode
			lpmyconfig->encoder_quality_mode = SendMessage(GetDlgItem(hwndDlg, IDC_QUALITY_MODE), CB_GETCURSEL, 0, 0);

			// input format
			lpmyconfig->encoder_force_input_format = (IsDlgButtonChecked(hwndDlg, IDC_FORCE_INPUT_FORMAT) == BST_CHECKED) ? 1 : 0;
			if (IsDlgButtonChecked(hwndDlg, IDC_FIF_RGB) == BST_CHECKED)
				lpmyconfig->encoder_input_format=COLORFORMAT_RGB32;
			else if (IsDlgButtonChecked(hwndDlg, IDC_FIF_YUY2) == BST_CHECKED)
				lpmyconfig->encoder_input_format = COLORFORMAT_YUY2;
			else 
				lpmyconfig->encoder_input_format = COLORFORMAT_YV12;

			// rgb-to-yuv conversion
			if (IsDlgButtonChecked(hwndDlg, IDC_RGB2YUV_601) == BST_CHECKED)
				lpmyconfig->encoder_RGB_to_YUV_conversion = RGB2YUV_601;
			else 
				lpmyconfig->encoder_RGB_to_YUV_conversion = RGB2YUV_UNCHANGED;

			// input yv12 chroma sampling
			if (IsDlgButtonChecked(hwndDlg, IDC_YV12_CHROMA_IN_DV) == BST_CHECKED)
				lpmyconfig->encoder_YV12_chroma_sampling = YV12_CHROMASAMPLING_DV;
			else if (IsDlgButtonChecked(hwndDlg, IDC_YV12_CHROMA_IN_MPEG2_PROGRESSIVE) == BST_CHECKED)
				lpmyconfig->encoder_YV12_chroma_sampling = YV12_CHROMASAMPLING_MPEG2_P;
			else 
				lpmyconfig->encoder_YV12_chroma_sampling = YV12_CHROMASAMPLING_MPEG2_I;

			// output format
			lpmyconfig->decoder_force_output_format = (IsDlgButtonChecked(hwndDlg, IDC_FORCE_OUTPUT_FORMAT) == BST_CHECKED) ? 1 : 0;
			if (IsDlgButtonChecked(hwndDlg, IDC_FOF_RGB) == BST_CHECKED)
				lpmyconfig->decoder_output_format = COLORFORMAT_RGB32;
			else if (IsDlgButtonChecked(hwndDlg, IDC_FOF_YUY2) == BST_CHECKED)
				lpmyconfig->decoder_output_format = COLORFORMAT_YUY2;
			else 
				lpmyconfig->decoder_output_format = COLORFORMAT_YV12;

			// yuv-to-rgb conversion
			if (IsDlgButtonChecked(hwndDlg, IDC_YUY2RGB_601) == BST_CHECKED)
				lpmyconfig->decoder_YUV_to_RGB_conversion = RGB2YUV_601;
			else 
				lpmyconfig->decoder_YUV_to_RGB_conversion = RGB2YUV_UNCHANGED;

			// output yv12 chroma sampling
			if (IsDlgButtonChecked(hwndDlg, IDC_YV12_CHROMA_OUT_DV) == BST_CHECKED)
				lpmyconfig->decoder_YV12_chroma_sampling = YV12_CHROMASAMPLING_DV;
			else if (IsDlgButtonChecked(hwndDlg, IDC_YV12_CHROMA_OUT_MPEG2_PROGRESSIVE) == BST_CHECKED)
				lpmyconfig->decoder_YV12_chroma_sampling = YV12_CHROMASAMPLING_MPEG2_P;
			else 
				lpmyconfig->decoder_YV12_chroma_sampling = YV12_CHROMASAMPLING_MPEG2_I;

			// dct-248 mode selection
			iTemp = GetDlgItemInt(hwndDlg, IDC_DCT248_THRESHOLD, NULL, FALSE);
			lpmyconfig->encoder_dct248_threshold = LIMIT_MIN_MAX( iTemp, 0, 255 );
			iTemp = GetDlgItemInt(hwndDlg, IDC_DCT248_COUNTS, NULL, FALSE);
			lpmyconfig->encoder_dct248_counts = LIMIT_MIN_MAX( iTemp, 0, 64 );

			// classification
			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_Y0, NULL, FALSE);
			lpmyconfig->encoder_classification_Y[0] = LIMIT_MIN_MAX( iTemp, 0, 255 );
			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_Y1, NULL, FALSE);
			lpmyconfig->encoder_classification_Y[1] = LIMIT_MIN_MAX( iTemp, lpmyconfig->encoder_classification_Y[0], 255 );
			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_Y2, NULL, FALSE);
			lpmyconfig->encoder_classification_Y[2] = LIMIT_MIN_MAX( iTemp, lpmyconfig->encoder_classification_Y[1], 255 );

			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_CR0, NULL, FALSE);
			lpmyconfig->encoder_classification_V[0] = LIMIT_MIN_MAX( iTemp, 0, 255 );
			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_CR1, NULL, FALSE);
			lpmyconfig->encoder_classification_V[1] = LIMIT_MIN_MAX( iTemp, lpmyconfig->encoder_classification_V[0], 255 );
			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_CR2, NULL, FALSE);
			lpmyconfig->encoder_classification_V[2] = LIMIT_MIN_MAX( iTemp, lpmyconfig->encoder_classification_V[1], 255 );

			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_CB0, NULL, FALSE);
			lpmyconfig->encoder_classification_U[0] = LIMIT_MIN_MAX( iTemp, 0, 255 );
			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_CB1, NULL, FALSE);
			lpmyconfig->encoder_classification_U[1] = LIMIT_MIN_MAX( iTemp, lpmyconfig->encoder_classification_U[0], 255 );
			iTemp = GetDlgItemInt(hwndDlg, IDC_CLASS_CB2, NULL, FALSE);
			lpmyconfig->encoder_classification_U[2] = LIMIT_MIN_MAX( iTemp, lpmyconfig->encoder_classification_U[1], 255 );

			// analyzer settings and color format
			lpmyconfig->analyzer_show_block_errors = (IsDlgButtonChecked(hwndDlg, IDC_SHOW_BE) == BST_CHECKED) ? 0x40000000 : 0;
				 if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_BE_YUY2)  == BST_CHECKED) lpmyconfig->analyzer_show_block_errors |= COLORFORMAT_YUY2;
			else if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_BE_YV12)  == BST_CHECKED) lpmyconfig->analyzer_show_block_errors |= COLORFORMAT_YV12;
			else if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_BE_RGB24) == BST_CHECKED) lpmyconfig->analyzer_show_block_errors |= COLORFORMAT_RGB24;
			else																    lpmyconfig->analyzer_show_block_errors |= COLORFORMAT_RGB32;

			lpmyconfig->analyzer_show_dct_type = (IsDlgButtonChecked(hwndDlg, IDC_SHOW_DCTT) == BST_CHECKED) ? 0x40000000 : 0;
				 if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_DCTT_YUY2)  == BST_CHECKED) lpmyconfig->analyzer_show_dct_type |= COLORFORMAT_YUY2;
			else if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_DCTT_YV12)  == BST_CHECKED) lpmyconfig->analyzer_show_dct_type |= COLORFORMAT_YV12;
			else if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_DCTT_RGB24) == BST_CHECKED) lpmyconfig->analyzer_show_dct_type |= COLORFORMAT_RGB24;
			else																      lpmyconfig->analyzer_show_dct_type |= COLORFORMAT_RGB32;

			lpmyconfig->analyzer_show_block_class = (IsDlgButtonChecked(hwndDlg, IDC_SHOW_BC) == BST_CHECKED) ? 0x40000000 : 0;
				 if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_BC_YUY2)  == BST_CHECKED) lpmyconfig->analyzer_show_block_class |= COLORFORMAT_YUY2;
			else if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_BC_YV12)  == BST_CHECKED) lpmyconfig->analyzer_show_block_class |= COLORFORMAT_YV12;
			else if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_BC_RGB24) == BST_CHECKED) lpmyconfig->analyzer_show_block_class |= COLORFORMAT_RGB24;
			else																    lpmyconfig->analyzer_show_block_class |= COLORFORMAT_RGB32;

			lpmyconfig->analyzer_show_quantizer_number = (IsDlgButtonChecked(hwndDlg, IDC_SHOW_QN) == BST_CHECKED) ? 0x40000000 : 0;
				 if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_QN_YUY2)  == BST_CHECKED) lpmyconfig->analyzer_show_quantizer_number |= COLORFORMAT_YUY2;
			else																	lpmyconfig->analyzer_show_quantizer_number |= COLORFORMAT_YV12;

			lpmyconfig->analyzer_show_quantizer_decoded = (IsDlgButtonChecked(hwndDlg, IDC_SHOW_QD) == BST_CHECKED) ? 0x40000000 : 0;
				 if (IsDlgButtonChecked(hwndDlg, IDC_SHOW_QD_YUY2)  == BST_CHECKED) lpmyconfig->analyzer_show_quantizer_decoded |= COLORFORMAT_YUY2;
			else																	lpmyconfig->analyzer_show_quantizer_decoded |= COLORFORMAT_YV12;

			save_configuration(CONFIGURATION_FILENAME);

		case IDCANCEL:
		  EndDialog(hwndDlg, 0);
		  break;

		case IDDEFAULT:
			memcpy( lptempconfig, lpmyconfig, sizeof(configvars_t) );
			memcpy( lpmyconfig, lpmyconfig_default, sizeof(configvars_t) );
			SendMessage(hwndDlg, WM_INITDIALOG, 0, 0);
			memcpy( lpmyconfig, lptempconfig, sizeof(configvars_t) );
			break;


		default:;
		  //return AboutDialogProc(hwndDlg, uMsg, wParam, lParam);    // handle email and home-page buttons
		}
	}

	return FALSE;
}


